/*global $, window*/
$.fn.addLoader = function () {
    var $loader = $("<img/>").attr("src", "static/img/loading_dots.gif").attr("width", "25px").addClass("loader");
    return this.each(function () {
        if (($(this).children(".loader")).length === 0) {
            $(this).append($loader);
        }
    });
};
$.fn.addDoneIcon = function () {
    var $done = $("<img/>").attr("src", "static/img/check.png").attr("width", "20px").addClass("done");
    return this.each(function () {
        if (($(this).children(".done")).length === 0) {
            $(this).append($done);
        }
    });
};

$(function () {
    "use strict";
    var done = false,
        prev_status = "",
        callbacks = {},
        wait_for_status = function(status, callback) {
            if (!(status in callbacks)) {
                callbacks[status] = [];
            }
            callbacks[status].push(callback);
        },
        check_status = function () {
            $.ajax({
                url: "status",
                cache: false,
                dataType: "json",
                method: "GET",
                success: function (data, status, jqXHR) {
                    var callback;
                    if (data.status !== prev_status) {
                        var $current_list = $("#actions-" + data.status).addClass("current"),
                            current_list_id = $current_list.attr("listid");
                        if ($current_list.hasClass("error")) {
                            $(".actionList").hide();
                        } else {
                            $(".actionList.error").hide();
                            $(".actionList").each(function () {
                                if ($(this).attr("listid") < current_list_id) {
                                    $(this).removeClass("current");
                                    if ($(this).hasClass("showIfPassed")) {
                                        $(this).slideDown(100);
                                    } else {
                                        $(this).hide();
                                    }
                                    if ($(this).hasClass("hasLoader")) {
                                        $(this).find(".loader").remove();
                                        $(this).children(".working").hide();
                                        $(this).children(".done").show();
                                    }
                                }
                            });
                        }
                        $current_list.slideDown(100);
                        if (data.status === "running") {
                            done = true;
                            setTimeout(function () {
                                var host = window.location.host,
                                    url = "http://" + host + "/stereo";
                                window.open(url);
                                $current_list.find(".loader").remove();
                                $current_list.find("#popup-blocked-href").attr("href", url);
                                $current_list.find(".delay").slideDown();
                            }, 500);
                        }
                        $current_list.children(".working").each(function () {
                            $(this).addLoader();
                        });
                        if(data.status in callbacks) {
                            for (var index in callbacks[data.status]) {
                                callback = callbacks[data.status].pop(index);
                                callback();
                            }
                        }
                        prev_status = data.status;
                    }
                    if (!done) {
                        setTimeout(function () {
                            check_status();
                        }, 4000);
                    }
                },
                error: function(jqXHR, textStatus, error) {
                    $(".actionList").hide();
                    $("#actions-error").show();
                }
            });
        };
    check_status();
    /*
     * Click behaviours
     */
    $("#actions").on("click", "#action-download", function (event) {
        var proxy_data = $("#download-form").serialize();
        event.preventDefault();
        if ($(".current").attr("id") === "actions-not_present") {
            proxy_data = "";
        } else {
            proxy_data = $("#download-form").serialize();
        }
        var $this = $(this);
        $.ajax({
            url: "cmd/download",
            type: "POST",
            data: proxy_data,
            success: function (data, status, jqXHR) {
                data = JSON.parse(data);
                if (data.status === "Ok") {
                    $("#actions-not_present").add("#actions-download_failed").removeClass("current").hide();
                    $("#actions-downloading").addClass("current").show()
                        .find(".working").addLoader().show()
                        .find(".done").hide();
                    prev_status = "";
                    wait_for_status("downloading", function() {
                        wait_for_status("downloaded", function () {
                            $("#actions-downloaded").removeClass("current").hide();
                            $("#actions-installing").addClass("current").show()
                                .find(".working").addLoader().show()
                                .find(".done").hide();
                            prev_status = "";
                            $.ajax({
                                url: "cmd/install",
                                type: "POST",
                                success: function (data, status, jqXHR) {
                                    console.log("Install command sent successfully");
                                },
                                error: function(jqXHR, textStatus, error) {
                                    console.log(error);
                                }
                            });
                        });
                    });
                }
            },
            error: function(jqXHR, textStatus, error) {
                console.log(error);
            }
        });
    });
    $("#actions").on("click", "#action-install", function () {
        var $this = $(this);
        $this.parent().addLoader();
        $this.prop("disabled", true);
        $.ajax({
            url: "cmd/install",
            type: "POST",
            success: function (data, status, jqXHR) {
                wait_for_status("installing", function() {
                    $this.prop("disabled", false);
                    $this.parent().find(".loader").remove();
                });
            },
            error: function(jqXHR, textStatus, error) {
                $this.parent().find(".loader").remove();
                $this.prop("disabled", false);
                console.log(error);
            }
        });
    });
    /*
     * End click behaviours
     */
});
